
Function init()
	m.dataCreatedByInit = "dataCreatedByInitValue"
End Function

sub eventLoopFunction()
	print "MyTask eventLoopFunction started"
	scene = m.top.metadata
	if scene = Invalid
		print "eventLoopFunction scene invalid"
		return
	end if
	titleLabel = scene.findNode("titleLabel")
	if titleLabel = invalid
	    print "eventLoopFunction titleLabel not found"
		return
	end if
    m.port = CreateObject("roMessagePort")
    m.top.observeFieldScoped("metadata", m.port)
    m.top.observeField("command", m.port)

	threadinfo = m.top.threadinfo()
	'print "eventLoopFunction json threadinfo="FormatJson(threadinfo)
	m.dataCreatedByInit = "dataCreatedByInitChangedByLoopFunc"
	m.dataCreatedByLoopFunction = "dataCreatedByLoopFunctionValue"
	FunctionCannotBePaasedToOutsideEventLoopFunction()
	print "MyTask eventLoopFunction, starting loop..." chr(10) chr(10)
    while(true)
        msg = wait(0, m.port)
        msgType = type(msg)
        if msgType = "roSGNodeEvent"
            if msg.GetField() = "command" then
                command = msg.GetData()
				if command = "quit"
					print "MyTask while: quit due to" "command="command
					exit while
				end if
				executeCommand(command, titleLabel)
			end if
		end if
		print "MyTask while: msgType="msgType " , command="command "back to loop"chr(10) chr(10)

	end while	
	print "MyTask eventLoopFunction exit"
End Sub

Sub executeCommand(command As String, titleLabel as Object)
	print "MyTask executeCommand command="command " , m.dataCreatedByLoopFunction="m.dataCreatedByLoopFunction "should see output from myFunction below"
	m.dataWithFunction.myFunction()
	print "Demo result: var inited by loopFunc can be accessed here, as seen in" " m.dataCreatedByLoopFunction="m.dataCreatedByLoopFunction
	titleLabel.text = "command:" + command
End Sub

Function InterfaceFunction(params As Object)
	print "MyTask InterfaceFunction"  " , m.dataCreatedByInit="m.dataCreatedByInit     " , m.dataCreatedByLoopFunction="m.dataCreatedByLoopFunction 
	print "Demo result: interface function no access to m.dataCreatedByLoopFunction as seen in " " m.dataCreatedByLoopFunction="m.dataCreatedByLoopFunction 
End Function

Function FunctionCannotBePaasedToOutsideEventLoopFunction()
    m.dataWithFunction = {
		myData: "myDataValue"
        myFunction: MyFunctionName
    }
	m.top.dataWithFunction = m.dataWithFunction
	print "m.dataWithFunction.myFunction=" m.dataWithFunction.myFunction ", m.top.dataWithFunction.myFunction="m.top.dataWithFunction.myFunction", m.top.dataWithFunction.myData="m.top.dataWithFunction.myData
	print "Demo result: function cannot be passed to task node and interface field, as seen in" " m.top.dataWithFunction.myFunction="m.top.dataWithFunction.myFunction
End Function

Sub MyFunctionName()
    print "MyFunctionName entered"
End Sub
'output: m.dataWithFunction.myFunction=<Function: myfunctionname>, m.top.dataWithFunction.myFunction=invalid, m.top.dataWithFunction.myData=myDataValue
' key info to watch: m.top.dataWithFunction.myFunction=invalid, and therefore no way to pass this info out thru interface field.
